import { _FontStructure } from './font-structure';
export declare class _PdfCompactFontParser {
    _bytes: Uint8Array;
    _properties: any;
    _isAnalysisEnabled: boolean;
    _compactFontFormat: _PdfCompactFormatFont;
    _values: any;
    _characterValidationData: any;
    _characterValidationData12: any;
    _compactCharSetPredefinedTypes: any;
    _standardCharSet: string[];
    _expertCharSet: string[];
    _expertSubsetCharSet: string[];
    _standardEncodingChars: any;
    _widths: any;
    _pos: number;
    constructor(file: any, properties: any, isAnalysisEnabled: boolean);
    _parsePrivateDictionary(parentDictionary: any): any;
    _parse(properties?: any): _PdfCompactFormatFont;
    _parseCharStrings(charStrings: any, localSubroutineIndex: any, globalSubroutineIndex: any, fontDictionarySelect: any, fontDictionaryArray: any, //eslint-disable-line
    privateDictionary: any): any;
    _parseFontDictionarySelect(pos: number, length: number): any;
    _parseCharSets(pos: any, length: any, strings: any, characterIdentifier: any): any;
    _readSupplement(bytes: any, pos: number, encoding: any, charSet: any, strings: any): any;
    _parseEncoding(pos: any, properties: any, strings: any, charSet: any): any;
    private _parseHeader;
    _parseOperand(dictionary: any): number;
    _parseFloatOperand(dictionary: any): number;
    _parseDictionary(dictionary: any): [number, number[]][];
    _parseIndex(pos: number): {
        obj: _PdfCompactFontIndex;
        endPos: number;
    };
    _parseNameIndex(index: {
        count: number;
        _get: (i: number) => Uint8Array;
    }): string[];
    _parseStringIndex(index: {
        count: number;
        _get: (i: number) => Uint8Array;
    }): _PdfCompactFontStrings;
    _createDictionary(type: any, dictionary: [number, number[]][], strings: _PdfCompactFontStrings): any;
    _parseCharString(state: any, //eslint-disable-line
    data: number[], localSubroutineIndex: {
        count: number;
        get: (index: number) => number[];
    }, globalSubroutineIndex: {
        count: number;
        get: (index: number) => number[];
    }): any;
    _emptyPrivateDictionary(parentDictionary: any): void;
}
export declare class _PdfCompactFormatFont {
    header: any;
    names: any;
    topDictionary: any;
    strings: _PdfCompactFontStrings;
    globalSubroutineIndex: any;
    encoding: any;
    charSet: any;
    charStrings: any;
    fontDictionaryArray: any;
    fontDictionarySelect: any;
    isCharacterIdentifierFont: boolean;
    standardEncodingChars: any;
    widths: any;
    constructor();
    _duplicateFirstGlyph(): void;
    _hasGlyphId(id: any): boolean;
}
export declare class _PdfCompactFontHeader {
    major: any;
    minor: any;
    headerSize: any;
    offSize: any;
    constructor(major: any, minor: any, headerSize: any, offSize: any);
}
export declare class _PdfCompactFontStrings {
    strings: any;
    _numberOfStandardCompactFontStrings: number;
    _compactFontStandardStrings: string[];
    constructor();
    _get(index: number): any;
    _fetchStringIdentifier(text: any): number;
    _add(value: any): void;
    readonly count: number;
}
export declare class _PdfCompactFontIndex {
    objects: any;
    length: number;
    constructor();
    add(data: any): void;
    set(index: number, data: any): void;
    _get(index: number): any;
    readonly count: number;
}
export declare class _PdfCompactFontDictionary {
    keyToNameMap: any;
    nameToKeyMap: any;
    defaults: any;
    types: any;
    opcodes: any;
    order: any;
    strings: any;
    values: any;
    constructor(tables: any, strings: any);
    _setByKey(key: any, value: any): boolean;
    _setByName(name: any, value: any): void;
    _hasName(name: any): any;
    _getByName(name: string): any;
    _removeByName(name: any): any;
    _createTables(layout: any): any;
}
export declare class _PdfCompactFontTopDictionary extends _PdfCompactFontDictionary {
    privateDictionary: any;
    static readonly _tables: any;
    constructor(strings?: any);
    static _createTables(): any;
}
export declare class _PdfCompactFontPrivateDictionary extends _PdfCompactFontDictionary {
    strings: any;
    subroutineIndex: any;
    tables: any;
    constructor(strings?: string);
}
export declare class _PdfCompactFontCharacterSet {
    predefined: any;
    format: any;
    charSet: any;
    raw: any;
    constructor(predefined: any, format: any, charSet: any, raw?: any);
}
export declare class _PdfCompactFontEncoding {
    predefined: any;
    format: any;
    charSet: any;
    raw: any;
    encoding: any;
    constructor(predefined: any, format: any, encoding: any, raw: any);
}
export declare class _PdfCompactFontSelect {
    format: any;
    fontDictionarySelect: any;
    constructor(format: any, fontDictionarySelect: any);
    _getFontDictionaryIndex(glyphIndex: number): any;
}
export declare class _PdfCompactFontOffsetTracker {
    offsets: any;
    constructor();
    _isTracking(key: any): boolean;
    _track(key: any, location: any): void;
    _offset(value: any): void;
    _setEntryLocation(key: any, values: any, output: any): void;
}
export declare class _PdfCompactFontCompiler {
    compactFont: any;
    constructor(compactFont: any);
    compile(): any;
    _transform(m1: any, m2: any): any;
    _encodeNumber(value: any): any;
    _encodeFloat(count: any): number[];
    _encodeInteger(value: number): number[];
    _compileHeader(header: any): any;
    _compileNameIndex(names: any): any;
    _compileTopDictionary(dictionary: any, length: any, removeCidKeys: any): any;
    _compilePrivateDictionary(dictionary: any, trackers: any, output: any): void;
    _compileDictionary(dictionary: any, offsetTracker: any): any;
    _compileStringIndex(strings: any): any;
    _compileCharStrings(charStrings: any): any;
    _compileCharSet(charSet: any, glyphCount: any, strings: any, isCharacterIdentifierFont: any): any;
    _compileEncoding(encoding: any): any;
    _compileFontDictionarySelect(fontDictionarySelect: any): any;
    _compileTypedArray(data: any): any;
    _compileIndex(index: any, trackers?: any): any;
}
export declare class _PdfCompactFont {
    properties: _FontStructure;
    compactFont: any;
    standardCharacter: any;
    data: any;
    _builtInEncoding: any;
    constructor(file: any, properties: any);
    readonly _glyphCount: number;
    _getCharSet(): any;
    _getGlyphMapping(): {
        [key: number]: number;
    };
    _hasGlyphId(id: number): boolean;
    _type1FontGlyphMapping(properties: any, builtInEncoding: any, glyphNames: any): any;
    _createBuiltInEncoding(): void;
}
